"""
Extract portion of data from dataset to build unsupervisd dataset
"""

import random


def file_len(fname):
    with open(fname) as f:
        for i, l in enumerate(f):
            pass
    return i + 1


data_list = '../../../data/Kitti/all-images.txt'
out_folder = '../../../data/'

print('counting element in file...')
images = []
masks = []
n_tot = file_len(data_list)
n_divided_2 = n_tot // 2
n_divided_4 = n_tot // 4
n_divided_8 = n_tot // 8
n_divided_100 = n_tot // 100
'''
# n/2
f = open(data_list, 'r')
print('producing n/2 files')
list1 = []
list2 = []
lines = []
for line in f:
    lines.append(line)
random.shuffle(lines)
i = 0
for line in lines:
    if i < n_divided_100:
        list1.append(line)
    else:
        list2.append(line)
    i = i + 1

print(str(len(list1)) + ' ' + str(len(list2)))

with open(out_folder + 'train_n_divided_100.txt', 'w') as f1:
    for item1 in list1:
        f1.write(item1)
f1.close()

with open(out_folder + 'unsupervised_n_divided_100.txt', 'w') as f2:
    for item2 in list2:
        f2.write(item2)
f2.close()
'''

f = open(data_list, 'r')
list1 = []
list2 = []
list3 = []
lines = []
train = 130
val = 40
test = 30
for line in f:
    lines.append(line)
random.shuffle(lines)
i = 0
for line in lines:
    if i < train:
        list1.append(line)
    elif i < train + val:
        list2.append(line)
    else:
        list3.append(line)
    i = i + 1

print(str(len(list1)) + ' ' + str(len(list2)) + ' ' + str(len(list3)))

with open(out_folder + 'train.txt', 'w') as f1:
    for item1 in list1:
        f1.write(item1)
f1.close()

with open(out_folder + 'val.txt', 'w') as f2:
    for item2 in list2:
        f2.write(item2)
f2.close()

with open(out_folder + 'test.txt', 'w') as f3:
    for item3 in list3:
        f3.write(item3)
f3.close()
f.close()
